
/*  META-KNOWLEDGE FOR OWEN's RESATISFACTION INTERPRETERS   */

   /* ABOUT THE INTERPRETER GOALS */

   meta_goal(solve(_Theory, Goal), Goal).
   meta_goal(solve_x(_Theory, Goal), Goal).

   /* ABOUT THE LANGUAGE PROCESSED */
 
   structure_decomposed((_,_)).
   structure_decomposed(true).

   terminal_atom(X) :- sys(X).

   /* ABOUT THE SUPPORT PREDICATES USED */

   /* !,fail to protect against similar knowledge from previous
      run */

   imperative(_X) :- !,fail.
   export(_X) :- !,fail.

   /*  FOR DRIVER   */

   flavor(resatisfaction, solve(_Theory,_Goal)).
   flavor(resatisfaction, solve_x(_Theory,_Goal)).

  /*  FOR FILE INTERFACE  */
  /* NOTE:  The programs should be stored as a set of owen_member/2 facts */

   rule_head((owen_member(_Theory, (Head :-_Body)):-true), Head).

   generate_functor_name(solve(_,_), ObjGoal, Functor) :-
        ObjGoal =.. [Functor|_ObjArgs].
   generate_functor_name(solve_x(_,_), ObjGoal, Functor_x) :-
        ObjGoal =.. [Functor|_ObjArgs],
	append_atoms(Functor, '_x', Functor_x).


%% END OF META_K.PRO %%%
