

/* KNOWLEDGE FOR USING ACCUMULATOR ENHANCEMENT FOR SUMMING 
*/

% init_acc(Initial)
  init_acc(0).

% add_to_acc(In, Goal, Out)
  add_to_acc(In, _, In).

add_to_acc_head(is_tree(leaf(X)), In, Out) :-!,
    Out is In+X.
add_to_acc_head(_, In, Out).

support_goals(X) :- !,fail.

expand_predicate(acc(is_tree(X),Y,Z), f(X, Y, Z)).
expand_predicate(acc(is_tree(X),Y), f(X, Y)).
