
/* KNOWLEDGE TO USE DOWN ENHANCEMENT FOR PROPAGATING PRODUCT */

context_from_system_goal(Goal, 1).
context_from_support_goal(Goal, 1).

merge_context_at_body(Mid1, Mid2,V) :-
      V is Mid1*Mid2.

merge_context_at_head(HeadC, BodyC, V) :-
	V is BodyC * HeadC.

support_goals(X) :-!,fail.


/* SPECIFIC FOR TREE */
up_context_head(is_tree(leaf(X)), X) :-!.
up_context_head(X, 1).

expand_predicate(up_context(is_tree(X),C), prod(X, C)).

