

flavor(loop, loop(Goal,Stack)).

meta_goal(loop(Goal,_Stack), Goal).

structure_decomposed((A,B)).
structure_decomposed(true).

terminal_atom(X) :- sys(X).

immediate(unfold_rule(X,Y)) :- nonvar(X).
export(dcg_rule(A,B)).
export(clause(A,B)).
export(not_member(A, InS)).

rule_head((A :-B), A).

  loop(true, _InS) :-!.
  loop((A,B), InS) :-
       unfold_rule(A, HeadA),!,
       not_member(HeadA, InS),
       OutS = [HeadA|InS],
       call(A),
       loop(B, OutS).
  loop((A,B), InS) :- !,
      loop(A, InS),
      loop(B, InS).
  loop(A, _Stack) :- 
      sys(A),!,
      call(A).
  loop(A, Stack) :- 
      clause(A,C),
      loop(C, Stack).

  unfold_rule(dcg_rule(Head,Body), Head).

  unfold_rule(clause(A,B), A).

  unfold_rule(edge(X,Y), X).
