
  /* Interpreter to count the number of reductions made
     for proving a goal
     See: The Art of Prolog, Sterling and Shapiro for explanation
  */

  count(true,0) :-!.
  count((A,B),C) :- !,
      count(A,D),
      count(B,E),
      C is D+E.
  count(A,0) :- 
      sys(A),!,
      call(A).
  count(A,B) :- 
      clause(A,C),
      count(C,D),
      B is D+1.


