
  /*  
    Interpreter to return proof tree for a computation
    See: The Art of Prolog, Sterling and Shapiro for details
  */

  proof(true,true) :-!.
  proof((A,B),(C,D)) :- !, proof(A,C),proof(B,D).
  proof(A,(A :-sys)) :- 
      sys(A),!,
      call(A).
  proof(A,(A:-C)) :- clause(A,B),proof(B,C).

