
/*   NDFA INTERPRETER  */
 
accept(Xs) :- initial(Q), accept(Q, Xs, []).

accept(Q, [X|Xs], S) :- 
      delta(Q, X, S, Q1, S1),
      accept(Q1, Xs, S1).
accept(Q, [], []) :- final(Q).


/* Taken from The Art of Prolog, Sterling and Shapiro */
