
/*  META-KNOWLEDGE FOR PSOLVE PARTIAL EVALUATOR */

   /* ABOUT THE INTERPRETER GOALS */

   meta_goal(psolve(Goal,_Residue), Goal).

   /* ABOUT THE LANGUAGE PROCESSED */
 
   structure_decomposed((_,_)).
   structure_decomposed(true).

   terminal_atom(X) :- sys(X).

   /* ABOUT THE SUPPORT PREDICATES USED */

   /* !,fail to protect against similar knowledge from previous
      run */

   imperative(psolve3(_,_)).
   immediate(cl(X,_)) :- nonvar(X).

   export(cl(X,_)) :- var(X).
   export(psolve_prim(X,_)) :- prolog_goal(built_in(X)).
   export(suspend(X)) :- var(X),!.
   export(suspend(count(X,_Y))) :- var(X).
   export(built_in(X)) :- var(X).

   extra_logical(psolve1(_,_)).
   extra_logical(psolve2(_,_)).

   /*  FOR DRIVER   */

   flavor(psolve, psolve(_Goal,_Residue)).

  /*  FOR FILE INTERFACE  */

   rule_head((Head :-_Body), Head) :-!.
   rule_head(Head, Head).


%% END OF META_K.PRO %%%
