   /*  META-KNOWLEDGE FOR UDI'S INTERPRETER  */
      meta_goal(solve(Goal,_Answer), Goal).
      meta_goal(solve(Goal,_InN,_OutN,_Dict), Goal).
      % says solve/2,4 are meta interpreter goals and Goal is their
      % meta-argument

   /*  ABOUT LANGUAGE */
      structure_decomposed((_,_)). % Interpreter recurses on (_,_)
                                   % without "chaining"
      terminal_atom(true).         % Recursion is terminates on true

   /*  ABOUT SUPPORT PROCEDURES */
      export(unify(Goal1,Goal2,Dict)) :- (var(Goal1);var(Goal2)),!.
      export(extract(Var,Dict,KeyVar)) :- var(Var).


   %   imperative(Goal) -- none --
   %   terminal_atom(Arg) -- none --

   %  FOR DRIVER
      flavor(udi, solve(_Goal,_Answer)).
      flavor(udi, solve(_Goal,_In,_Out,Dict)).

   %  FOR FILE INTERFACE
      rule_head((clause(Head,_Body,_N1,_N2) :-Etc), Head).
