:- current_op(P,A, =), op(P,yfx, ==>).  % Define ==> as an operator 

holding1(_3,_13==>pickup(_3),_5) :-
   acceptable(_5,_15),
%  block(_3),
   cleartop1(_3,_13,_15),
   ontable1(_3,_13,_15),
   empty_arm1(_13,_15).


%cleartop1(_3,_4,_5) :-
%   fact1(cleartop(_3,_4,_5)).
cleartop1(_3,_13==>unstack(_14,_3)==>putdown(_14),_5) :-
   acceptable(_5,_16),
%  diff_blk(_3,_14),
   acceptable(_16,_17),
   fact1(on(_14,_3,_13,_17)),
   fact1(cleartop(_14,_13,_17)),
   fact1(empty_arm(_13,_17)).
cleartop1(_3,S==>unstack(_18,_14)==>putdown(_18)==>unstack(_14,_3)==>putdown(_14),_5) :-
   acceptable(_5,_16),
%  diff_blk(_3,_14),
%  diff_blk(_18,_3),
   acceptable(_16,_17),
   on1(_14,_3,S==>unstack(_18,_14)==>putdown(_18),_17),
   cleartop1(_14,S==>unstack(_18,_14)==>putdown(_18),_17),
   empty_arm1(S==>unstack(_18,_14)==>putdown(_18),_17).

 
%on1(_3,_4,_5,_6) :-
%   fact1(on(_3,_4,_5,_6)).
on1(_3,_4,_13==>unstack(_14,_15)==>putdown(_14),_6) :-
%   diff_blk(_3,_4),
%   diff_blk(_3,_14),
%   diff_blk(_14,_15),
   acceptable(_6,_19),
   acceptable(_19,_20),
   fact1(on(_14,_15,_13,_20)),
   fact1(cleartop(_14,_13,_20)),
   fact1(empty_arm(_13,_20)),
   fact1(on(_3,_4,_13,_20)).
on1(_3,_4,S==>unstack(_18,_14)==>putdown(_18)==>unstack(_14,_15)==>putdown(_14),_6) :-
%   diff_blk(_3,_4),
%   diff_blk(_3,_14),
%   diff_blk(_15,_18),
%   diff_blk(_14,_15),
%   block(_14),
   acceptable(_6,_19),
   acceptable(_19,_20),
   on1(_3,_4,S==>unstack(_18,_14)==>putdown(_18),_20),
   on1(_14,_15,S==>unstack(_18,_14)==>putdown(_18),_20),
   cleartop1(_14,S==>unstack(_18,_14)==>putdown(_18),_20),
   empty_arm1(S==>unstack(_18,_14)==>putdown(_18),_20).

%ontable1(_3,_4,_5) :-
%   fact1(ontable(_3,_4,_5)).
ontable1(_3,_12==>unstack(_13,_14)==>putdown(_13),_5) :-
   acceptable(_5,_17),
%  diff_blk(_3,_13),
%  diff_blk(_13,_14),
   acceptable(_17,_18),
   fact1(on(_13,_14,_12,_18)),
   fact1(cleartop(_13,_12,_18)),
   fact1(empty_arm(_12,_18)),
   fact1(ontable(_3,_12,_18)).
ontable1(_3,S==>unstack(_30,_13)==>putdown(_30)==>unstack(_13,_14)==>putdown(_13),_5) :-
   acceptable(_5,_17),
%   diff_blk(_3,_13),
%   diff_blk(_13,_14),
%   diff_blk(_14,_30),
   acceptable(_17,_18),
   on1(_13,_14,S==>unstack(_30,_13)==>putdown(_30),_18),
   cleartop1(_13,S==>unstack(_30,_13)==>putdown(_30),_18),
   empty_arm1(S==>unstack(_30,_13)==>putdown(_30),_18),
   ontable1(_3,S==>unstack(_30,_13)==>putdown(_30),_18).

%empty_arm1(_3,_4) :-
%   fact1(empty_arm(_3,_4)).
empty_arm1(_11==>unstack(_12,_13)==>putdown(_12),_4) :-
   acceptable(_4,_15),
%   block(_12),
   acceptable(_15,_16),
   fact1(on(_12,_13,_11,_16)),
   fact1(cleartop(_12,_11,_16)),
   fact1(empty_arm(_11,_16)).
empty_arm1(S==>unstack(_30,_12)==>putdown(_30)==>unstack(_12,_13)==>putdown(_12),_4) :-
   acceptable(_4,_15),
%   block(_12),diff_blk(_13,_30),
   acceptable(_15,_16),
   on1(_12,_13,S==>unstack(_30,_12)==>putdown(_30),_16),
   cleartop1(_12,S==>unstack(_30,_12)==>putdown(_30),_16),
   empty_arm1(S==>unstack(_30,_12)==>putdown(_30),_16).

fact1(on(X,Y,S,W)) :-
	nstruct(S),fact(on(X,Y,S,W)).
fact1(cleartop(X,S,Z)) :-
	nstruct(S),fact(cleartop(X,S,Z)).
fact1(empty_arm(S,X)) :-
	nstruct(S),fact(empty_arm(S,X)).
fact1(ontable(X,S,W)) :-
	nstruct(S),fact(ontable(X,S,W)).

acceptable(D1,D2) :-
	 D1 > 0, D2 is D1-1.

% Now we describe a specific problem 
fact(on(b,a,s0,N)).
fact(on(c,b,s0,N)).
fact(ontable(a,s0,N)).
fact(cleartop(c,s0,N)).
fact(empty_arm(s0,N)).
block(a).
block(b).
block(c).

nstruct(X) :- var(X).
nstruct(X) :- atomic(X).


