/*

  This program was sent to me (Arun Lakhotia) by Ronen Feldman by
  e-mail for the purpose of experimenting with ProMiX.

    Date: Mon, 2 Jul 90 11:54:41 EDT
    From: feldman@cs.cornell.edu (Ronen Feldman)

  The program has been edited -- moved predicate definitions around,
  made one predicate per line, etc. for the sake of clarity of
  presentation. In the process the interpreter and data part of the
  code has also become explicit

   Arun Lakhotia -- July 2, 1990

*/

%----p1.dom
%---query p1(1,2)
%---general_query p1(X,Y) X and Y can be any 2 constants.
%---answer yes.

% INTERPRETER

p1(X,Y) :- 
   a(B,Y), 
   p1(X,B).
p1(X,Y) :- 
   a(V,Y), 
   b(U,X), 
   p1(U,V).
p1(X,Y) :- 
   c(X,Y).

% DATA

a(3,2).  a(4,3).  a(6,4).  a(8,6).

b(5,1).  b(7,5).

c(7,8).
