
% class:
         flavor(findAlld, findAlld(_,_,_)).

	 toplevel(findAll(_A,_B,_C),2).
% goal:
         meta_goal(findAlld(_Term, Goal, _Bag), Goal).

% struct:
         structure_decomposed(true).
         structure_decomposed((_,_)).
         structure_decomposed(A) :- sys(A).

% imperative:
	 imperative(findAll_conjunct_d(X, _Y)) :- var(X).

	 export(findAll_single_solution(_A,_B,_C)).
	 export(findAll_conjunct_d(X, _Y)) :- nonvar(X).

	 export(term_instances_d(_X,_Y,_Z,_A)).
	 export(make_diff_list(Z,_Q)) :- var(Z).
	 %% export(all_clauses(Goal,_Clauses)) :- var(Goal).


         immediate(findAll_system_predicate(_X,Y,_Z)) :-
               immediately_evaluable(Y).
	 immediate(all_clauses(Goal,_Clauses)) :- nonvar(Goal).


   rule_head((Head:-_Body), Head).
   rule_head(Head, Head).

%%
%%  Support procedures required
%%       Reified definitions of copy/2, unify/2
%%       make_diff_list/2 in utility.pro

%% Important changes required to specialize findall
%%
%%    In all_clauses/2 -- replaced clause/2 with unfold_clause/2
