
  /* USES ---> INSTEAD OF --.  */
:- current_op(X, Y, -->), op(X, Y, --->).

/*****   META KNOWLEDGE ABOUT THE INTERPRETER AND LANGUAGE   ******/

  /*  ABOUT THE INTERPRETER GOAL */
  meta_goal(dcg(Goal, _S0, _S1), Goal).

  /* ABOUT THE LANGUAGE */
  structure_decomposed((_,_)).
  structure_decomposed(X) :- proper_list(X).
  structure_decomposed({X}).

  /* ABOUT INTERPRETER'S PREDICATES */

  immediate(nonterminal(_)).
  immediate(proper_list(_)).
  immediate(dcg_rule(_,_)).

  imperative(dcg_body(_,_,_)).
  imperative(dcg_head(_)).

  export(connects(_,_,_)).
  export(call(_)).

  /*  FOR THE DRIVER */
  flavor(dcg, dcg(_Goal, _S0, _S1)).

  /* SYNTAX OF DATA IN FILE */

  rule_head(((X ---> _Y) :-true), X).


/* If the data is not loaded in prolog database like regular prolog
   program then the definitions in dcg.pro are not accessible to
   the prolog engine. Hence this clause is repeated here.
*/ 
   proper_list(List) :-
	   nonvar(List),
	   proper_list_1(List).

   proper_list_1([]).
   proper_list_1([_|List]) :-
	   proper_list(List).
