  should_take(A,B) :- 
      complains_of(A,C),
      suppresses(B,C),
      suitable(B,A).

  suppresses(aspirin,pain).
  suppresses(lomotil,diarrhea).

  suitable(A,B) :- does_not_aggravate(A,C),suffers_from(B,C).

  does_not_aggravate(aspirin,impaired_liver_function).
  does_not_aggravate(lomotil,peptic_ulcer).

  complains_of(john,pain).
  complains_of(sue,diarrhea).

  suffers_from(john,impaired_liver_function).
  suffers_from(sue,peptic_ulcer).

