
/*  META-KNOWLEDGE FOR COUNT AND PROOF INTERPRETERS   */

   /* ABOUT THE INTERPRETER GOALS */

   meta_goal(count(Goal,_Count), Goal).
   meta_goal(proof(Goal,_Proof), Goal).

   /* ABOUT THE LANGUAGE PROCESSED */
 
   structure_decomposed((_,_)).
   structure_decomposed(true).

   terminal_atom(X) :- sys(X).

   /* ABOUT THE SUPPORT PREDICATES USED */

   /* !,fail to protect against similar knowledge from previous
      run */

   imperative(_X) :- !,fail.
   export(_X) :- !,fail.

   /*  FOR DRIVER   */

   flavor(count, count(_Goal,_Count)).
   flavor(proof, proof(_Goal,_Proof)).

  /*  FOR FILE INTERFACE  */

   rule_head((Head :-_Body), Head) :-!.
   rule_head(Head, Head).


%% END OF META_K.PRO %%%
