
/*    KNOWLEDGE ABOUT NDFA INTERPRETER */

  /* ABOUT THE INTERPRETER GOAL */
  meta_goal(accept(Xs), Xs).
  meta_goal(accept(X, S1, _S2), S1).

  /* ABOUT THE LANGUAGE */

  structure_decomposed(X) :- nonvar(X),!.

  /* ABOUT THE INTERPRETER SUPPORT PREDICATES */

  imperative(_X) :- !,fail.
  export(_X) :- !, fail.

   /*  FOR THE DRIVER  */

  flavor(ndfa, accept(Xs)).
  flavor(ndfa, accept(X, _S1, _S2)).

   /*  HOW TO TRANSLATE INTERPRETER GOALS IN THE RESIDUE */

  expand_predicate(accept(X), palindrome(X)).
  expand_predicate(accept(X,Y,Z), palindrome(X,Y,Z)).

