
:- rdf([count, psolve]).
:- rdf(append).
:- rpf(meta_k).

:- set_value(loop_check_type, off).

t :- mixd(psolve(count(_X,_Y),_R)).

t(File) :- 
    nonvar(File),
    tell(File),
    t,
    told.


  mixd(Goal) :-
     drive_mix(Goal, Clause),
     display_clauses([Clause]), 
     fail.
  mixd(_Goal).

t2:- mixd(psolve(clause_o(_,_),_R)).

t3:- mixd(psolve(built_in(_),_R)).

  should_unfold(Goal) :-
       meta_goal(Goal, MetaArg),
       nonvar(MetaArg),!,
       ( structure_decomposed(MetaArg)
	; terminal_atom(MetaArg)).
  should_unfold(Goal) :- 
      imperative(Goal),!.
  should_unfold(Goal) :- 
       \+ export(Goal),
       \+ immediate(Goal).
