
:- rdf([count, 'clean/psolve']).
:- rdf(append).
:- rpf('clean/meta_k').

:- set_value(loop_check_type, off).

t :- mixd(psolve1(count(_X,_Y),_R)).

t(File) :- 
    nonvar(File),
    tell(File),
    t,
    told.


  mixd(Goal) :-
     drive_mix(Goal, Clause),
     display_clauses([Clause]), 
     fail.
  mixd(_Goal).

t2:- mixd(psolve1(clause_o(_,_),_R)).

t3:- mixd(psolve1(built_in(_),_R)).

  should_unfold(Goal) :-
       meta_goal(Goal, MetaArg),!,
       ( structure_decomposed(MetaArg)
	; terminal_atom(MetaArg)).
  should_unfold(Goal) :- 
      imperative(Goal),!.
  should_unfold(Goal) :- 
       \+ export(Goal),
       \+ immediate(Goal).

%% Commands for tracing

% mixd(psolve3(count(X,Y),R)).

% mix_transparent(expandable(count(_924,_925)),_2098,[psolve3(count(_1242,_1243),_1240)]).
