count(true,0).
count((A,B),N) :- 
    count(A,N1),
    count(B,N2),
    N is N1+N2.
count(A,N) :- 
    clause_o(A,B),
    count(B,N1),
    N is N1+1.

count(Goal,0) :- built_in(Goal), call(Goal).

suspend(count(A,_B)) :- var(A).
suspend(count(A,_B)) :- nonvar(A), 
         \+conjunction(A), 
         \+(A = true),
         \+built_in(A).

  built_in(_A is _B).
  built_in(_A =:= _B).
  built_in(_A =\= _B).
  built_in(_A < _B).
  built_in(_A =< _B).
  built_in(_A > _B).
  built_in(_A >= _B).
  built_in(call(_A)).
