/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: sys.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:45:37 CDT 1990
*   $Log:	sys.pro,v $
**   Revision 1.2  90/07/05  17:23:59  arun
**   New Release
**   
**   Revision 1.1  89/04/16  01:34:00  arun
**   Initial revision
**         */

/*%% sys predicates
%% Note that this may be an incomplete list!
*/

sysp([_|_]).                           sysp(close(_)).
sysp(abolish(_,_)).		      sysp(compare(_,_,_)).
sysp(revive(_,_)).		      sysp(compile(_)).
sysp(incore(_)).		      sysp(consult(_)).
sysp(asserta(_,_)).		      sysp(current_atom(_)).
sysp(asserta(_)).		      sysp(current_functor(_,_)).
sysp(assertz(_,_)).		      sysp(current_predicate(_,_)).
sysp(assertz(_)).		      sysp(current_op(_,_,_)).
sysp(retract(_)).		      sysp(fail).
sysp(clause(_,_,_)).		      sysp(fileerrors).
sysp(clause(_,_)).		      sysp(gc).
sysp(recorda(_,_,_)).		      sysp(gcguide(_)).
sysp(recordz(_,_,_)).		      sysp(halt).
sysp(recorded(_,_,_)).		      sysp(integer(_)).
sysp(instance(_,_)).		      sysp(keysort(_,_)).
sysp(erase(_)).			      sysp(listing).
sysp(true).			      sysp(listing(_)).
sysp(length(_,_)).		      sysp(log).
sysp(name(_,_)).		      sysp(nofileerrors).
sysp(op(_,_,_)).	              sysp(nogc).
sysp(var(_)).			      sysp(nolog).
sysp(atom(_)).			      sysp(nonvar(_)).
sysp(!).                              sysp(numbervars(_,_,_)).
sysp(','(_,_)).			      sysp(phrase(_,_)).
sysp(statistics).		      sysp(prompt(_,_)).
sysp(statistics(_,_)).		      sysp(read(_)).
sysp(functor(_,_,_)).		      sysp(reconsult(_)).
sysp(expand_term(_,_)).		      sysp(rename(_,_)).
sysp(debug).			      sysp(repeat).
sysp(debugging).		      sysp(restore(_)).
sysp(display(_)).		      sysp(save(_)).
sysp(get(_)).			      sysp(see(_)).
sysp(get0(_)).			      sysp(seeing(_)).
sysp(leash(_)).			      sysp(seen).
sysp(nl).			      sysp(setof(_,_,_)).
sysp(nodebug).			      sysp(sort(_,_)).
sysp(print(_)).			      sysp(tell(_)).
sysp(put(_)).			      sysp(telling(_)).
sysp(skip(_)).			      sysp(told).
sysp(tab(_)).			      sysp(trimcore).
sysp(trace).			      sysp(plsysp(_)).
sysp(ttyflush).			      sysp('LC').
sysp(ttyget(_)).		      sysp('NOLC').
sysp(ttyget0(_)).		      sysp(spy(_)).
sysp(ttynl).			      sysp(nospy(_)).
sysp(ttyput(_)).		      sysp(_=_).
sysp(ttyskip(_)).		      sysp(_ is _).
sysp(ttytab(_)).		      sysp(_==_).
sysp(write(_)).			      sysp(_\==_).
sysp(writeq(_)).		      sysp(_=.._).
sysp(ancestors(_)).		      sysp(_<_).
sysp(depth(_)).			      sysp(_>_).
sysp(maxdepth(_)).		      sysp(_=<_).
sysp(subgoal_of(_)).		      sysp(_>=_).
sysp(abort).			      sysp(_@<_).
sysp(arg(_,_,_)).		      sysp(_@=<_).
sysp(assert(_)).		      sysp(_@>=_).
sysp(atomic(_)).		      sysp(_@>_).
sysp(bagof(_,_,_)).		      sysp(_^_).
sysp(break).			      sysp(_=\=_).
				      sysp(_=:=_).

sysp(sys(_)).
sysp(sysp(_)).

sysp(predicate_property(_,_)).
